VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CircleMaker"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Attribute VB_Description = "CircleMaker"
Option Explicit

' The environment instance.
Public VBInstance As VBIDE.Application
Public Sub AfterClick()
Const pi = 3.14159

Dim R As Single
Dim Cx As Single
Dim Cy As Single
Dim x As Single
Dim y As Single
Dim theta As Single
Dim dtheta As Single
Dim min_x As Single
Dim max_x As Single
Dim min_y As Single
Dim max_y As Single
Dim ctl As Object
Dim controls As VBIDE.SelectedControlTemplates
Dim frm As Object

    If NoControls() Then Exit Sub
    
    Set frm = VBInstance.ActiveProject.ActiveForm
    Set controls = frm.SelectedControlTemplates
    
    ' Find the largest and smallest coordinates.
    Set ctl = controls.Item(0)
    min_x = ctl.Properties("Left")
    max_x = min_x + ctl.Properties("Width")
    min_y = ctl.Properties("Top")
    max_y = min_y + ctl.Properties("Height")
    
    For Each ctl In controls
        On Error Resume Next
        x = ctl.Properties("Left")
        If Err.Number = 0 Then
            If min_x > x Then min_x = x
            If max_x < x Then max_x = x
            y = ctl.Properties("Top")
            If min_y > y Then min_y = y
            If max_y < y Then max_y = y
        End If
        x = x + ctl.Properties("Width")
        If Err.Number = 0 Then
            If min_x > x Then min_x = x
            If max_x < x Then max_x = x
            y = y + ctl.Properties("Height")
            If min_y > y Then min_y = y
            If max_y < y Then max_y = y
        End If
        On Error GoTo 0
    Next ctl
   
    Cx = (min_x + max_x) / 2
    Cy = (min_y + max_y) / 2
    R = (max_x - min_x) / 2
    
    theta = 0
    dtheta = 2 * pi / controls.Count
    For Each ctl In controls
        On Error GoTo MoveOn
        
        x = Cx + R * Cos(theta)
        y = Cy + R * Sin(theta)
        ctl.Properties("Left") = _
            x - ctl.Properties("Width") / 2
        ctl.Properties("Top") = _
            y - ctl.Properties("Height") / 2
MoveOn:
        On Error GoTo 0
        theta = theta + dtheta
    Next ctl

End Sub
' ************************************************
' Return true if there are not controls selected.
' ************************************************
Function NoControls() As Boolean
    NoControls = True
    
    ' Sneak up on the collection of selected
    ' controls so we don't try to access an
    ' object that is Nothing.
    If VBInstance.ActiveProject Is Nothing Then _
        Exit Function
    If VBInstance.ActiveProject.ActiveForm _
        Is Nothing Then _
        Exit Function
    If VBInstance.ActiveProject.ActiveForm. _
        SelectedControlTemplates.Count < 1 Then _
        Exit Function
            
    NoControls = False
End Function



