Attribute VB_Name = "MainModule"
' ************************************************
' Property setter main program.
'
' This add-in allows the user to set any
' properties for a selected group of controls.
' ************************************************
Option Explicit

Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

' ************************************************
' The Main subroutine.
' ************************************************
Sub Main()
Dim section As String
Dim val As String * 256
Dim length As Long

    ' Check the correct section of VB.INI.
    section = "Add-Ins32"
    
    ' See if the PropertySetter.PropSet entry
    ' is in VBADDIN.INI.
    length = GetPrivateProfileString(section, _
        "PropertySetter.PropSet", "", val, _
        256, "VBADDIN.INI")
    
    ' If not, add it.
    If length = 0 Then
        WritePrivateProfileString section, _
            "PropertySetter.PropSet", "0", _
            "VBADDIN.INI"
    End If
End Sub
