VERSION 4.00
Begin VB.Form Splash 
   AutoRedraw      =   -1  'True
   BorderStyle     =   0  'None
   ClientHeight    =   4140
   ClientLeft      =   1035
   ClientTop       =   1470
   ClientWidth     =   6690
   ControlBox      =   0   'False
   Height          =   4545
   Left            =   975
   LinkTopic       =   "Form1"
   ScaleHeight     =   276
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   446
   ShowInTaskbar   =   0   'False
   Top             =   1125
   Width           =   6810
   Begin VB.CommandButton CmdOk 
      BackColor       =   &H000000FF&
      Cancel          =   -1  'True
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   0
      Top             =   2760
      Width           =   735
   End
   Begin VB.Timer SplashTimer 
      Interval        =   3000
      Left            =   3960
      Top             =   2760
   End
   Begin VB.Shape Shape1 
      BorderWidth     =   2
      Height          =   2655
      Left            =   840
      Shape           =   2  'Oval
      Top             =   600
      Width           =   5295
   End
   Begin VB.Label AboutLabel 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Copyright 1997, John Wiley && Sons, Inc."
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   255
      Index           =   0
      Left            =   1080
      TabIndex        =   2
      Top             =   2160
      Width           =   4815
   End
   Begin VB.Label AboutLabel 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "All rights reserved"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   255
      Index           =   1
      Left            =   2400
      TabIndex        =   1
      Top             =   2400
      Width           =   2175
   End
   Begin VB.Image QueryImage 
      Height          =   3045
      Left            =   600
      Picture         =   "SPLASH.frx":0000
      Top             =   360
      Width           =   5640
   End
End
Attribute VB_Name = "Splash"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ExpenseReporter splash screen and About dialog.
' ************************************************
Option Explicit

Dim timer_expired As Boolean
Dim ready_to_unload As Boolean

' ************************************************
' Arrange the form to be an About dialog or not.
' ************************************************
Property Let AboutDialog(value As Boolean)
Const MARGIN = 240

    If value Then
        SplashTimer.Enabled = False
        CmdOk.Visible = True
    Else
        SplashTimer.Enabled = True
        CmdOk.Visible = False
    End If
End Property

' ************************************************
' Flag the form as ready to unload.
'
' Unload the form if the timer has expired
' (indicating that the user has stared at it long
' enough) and ready_to_unload is true.
' ************************************************
Property Let ReadyToUnload(value As Boolean)
    ready_to_unload = value

    If timer_expired Then
        Unload Me
        EmployeeForm.Enabled = True
        EmployeeForm.SetFocus
        EmployeeForm.mnuFileLogon_Click
    End If
End Property

' ************************************************
' Give the form a shaped region.
' ************************************************
Sub ShapeForm()
Dim rgn As Long
Dim old_rgn As Long

    ' Set the form region.
    rgn = CreateEllipticRgn(56, 40, 409, 217)
    old_rgn = SetWindowRgn(hWnd, rgn, True)
End Sub

Private Sub CmdOk_Click()
    Unload Me
End Sub

' ************************************************
' Initialize form variables.
' ************************************************
Private Sub Form_Load()
Dim status As Long

    ' Add a copyright symbol.
    AboutLabel(0).Caption = Chr$(169) & AboutLabel(0).Caption
    
    ' Initially the form has just been presented
    ' and is not ready for unloading.
    timer_expired = False
    ready_to_unload = False

    ' Shape the form.
    ShapeForm
    
    ' Center the form.
    Left = (Screen.Width - Width) / 2
    Top = (Screen.Height - Height) / 2

    ' Make this window stay on top of others.
    #If Win32 Then
        status = SetWindowPos(hWnd, HWND_TOPMOST, _
            0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE)
    #Else
        SetWindowPos hWnd, HWND_TOPMOST, _
            0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
    #End If
End Sub



' ************************************************
' Indicate that the user has stared at the form
' for long enough.
'
' Unload the form if the timer has expired
' (indicating that the user has stared at it long
' enough) and ready_to_unload is true.
' ************************************************
Private Sub SplashTimer_Timer()
    timer_expired = True
    SplashTimer.Enabled = False
    
    If ready_to_unload Then
        Unload Me
        EmployeeForm.Enabled = True
        EmployeeForm.SetFocus
        EmployeeForm.mnuFileLogon_Click
    End If
End Sub
